//
//      SGXAWSParser.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.5
//

#include "SGXAWSParser.hpp"
#include "pself2.hpp"
#include "pself2_res.h"

// RXgN^
SGXAWSParser::SGXAWSParser(Void) : _isParseItemAttributes(true),
    _isParseImageUrl(false), _isParseOfferSummary(false),
    _isParseOffers(false), _isParseCustomerReviews(false),
    _isParseSimilarProducts(false), _isParseBrowserNodes(false),
    _isParseListmaniaLists(false),
    _itemAttributes(null), _imageUrl(null), _offerSummary(null), _offers(null),
    _customerReviews(null), _similarProducts(null), _browserNodes(null),
    _listmaniaLists(null)
{
    return;
}

// fXgN^
SGXAWSParser::~SGXAWSParser(Void)
{
    Clear();
    return;
}

// 
Void SGXAWSParser::Clear(Void)
{
	// ^Cg̃NA
    _title.Clear();
	// ISBN ̃NA
    _asin.Clear();

	// _itemAttributes \̂̍폜
	::delete _itemAttributes;
    _itemAttributes = null;

	// _itemAttributes \̂̍폜
    ::delete _imageUrl;
    _imageUrl = null;

	// _offerSummary \̂̍폜
    ::delete _offerSummary;
    _offerSummary = null;
    if (_offers != null) {
		// _offers \̂̍폜
        SFXArray<OfferRecPtr>::Enumerator enumerator = _offers->offers.GetFirstEnumerator();
        while (enumerator.HasNext()) {
            OfferRecPtr offer(enumerator.GetNext());
            delete offer;
        }
        _offers->offers.Clear();
        delete _offers;
        _offers = null;
    }
    
	// _customerReviews ̍폜
    if (_customerReviews != null) {
        SFXArray<ReviewRecPtr>::Enumerator enumerator = _customerReviews->reviews.GetFirstEnumerator();
        while (enumerator.HasNext()) {
            ReviewRecPtr review(enumerator.GetNext());
            delete review;
        }
        _customerReviews->reviews.Clear();
        delete _customerReviews;
        _customerReviews = null;
    }

	// _similarProducts ̍폜
    if (_similarProducts != null) {
        SFXArray<SimilarProductRecPtr>::Enumerator enumerator = _similarProducts->similarProducts.GetFirstEnumerator();
        while (enumerator.HasNext()) {
            SimilarProductRecPtr similarProduct(enumerator.GetNext());
            delete similarProduct;
        }
        _similarProducts->similarProducts.Clear();
        delete _similarProducts;
        _similarProducts = null;
    }
}

// ^O̒u
SFXAnsiString DecodeHtml(SFXAnsiStringConstRef string)
{
    return string.Replace("&lt;", '<').Replace("&gt;", '>').Replace("&quot;", '"').Replace("&amp;", '&');
}

// SOAP ̉
SFCError SGXAWSParser::ParseSOAP(SFXXMLElementPtr root)
{
    SFCError error= SFERR_NO_ERROR;
	SFXSOAPParser parser;
   
	// OԂȂ
    parser.SetDoNamespaces(false);
	// eϐ
    Clear();

	// ͂sꍇ
    if (error != SFERR_NO_ERROR) return error;
		
	if (root == null) return SFERR_INVALID_STATE;

	SFXXMLNodePtr child;
    
	// Item ^OT
	SFXList<SFXXMLNodePtr>* list = root->GetElementsByTagName("Item");
	// Item ^Oꍇ
	if (list != null && list->GetSize() > 0) {

		// vf擾
		child = list->Get(0); 
        
		for (child = child->GetFirstChild() ; child != null && error == SFERR_NO_ERROR ; child = child->GetNextSibling()) {
			
			// m[h ASIN ̏ꍇ	
			if (SFXAnsiString(child->GetNodeName()) == "ASIN") {		
				// m[h̕擾                       
				_asin = DecodeHtml(child->GetText());
					
			// m[h DetailPageURL ̏ꍇ                
			} else if (SFXAnsiString(child->GetNodeName()) == "DetailPageURL") {					
				// m[h̕擾     
				_detailPageURL = DecodeHtml(child->GetText());
				
			// m[h SalesRank ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "SalesRank") {						
				// m[h̕擾                
				// SalesRankɂ̓J}Ă̂ō폜                       
				_salesRank = child->GetText().Replace(',', "").AsSInt32();
					
			// m[h ItemAttributes ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "ItemAttributes") {				
				// ItemAttributes ^Ỏ͂邩ǂ                      
				if (_isParseItemAttributes) { 							
					// ItemAttributes ͂                           
					error = ParseItemAttributes(child->GetFirstChild());                      
				} else {					
					// ItemAttributes ^Ỏ͂Ȃꍇ						
					// ^Cĝ݉͂                           
					error = ParseTitle(child->GetFirstChild());       
				}
				
			// m[h SmallImage ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "SmallImage") {						
				// SmallImage ^Ỏ͂邩ǂ        
				if (_isParseImageUrl) {						
					// SmallImage ͂        
					error = ParseSmallImage(child->GetFirstChild());        
				}
			
			// m[h MediumImage ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "MediumImage") {		
				// MediumImage ^Ỏ͂邩ǂ                        
				if (_isParseImageUrl) {							
					// MediumImage ͂        
					error = ParseMediumImage(child->GetFirstChild());                        
				}
					
			// m[h LargeImage ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "LargeImage") {		
				// LargeImage ^Ỏ͂邩ǂ                       
				if (_isParseImageUrl) {		
					// LargeImage ͂                           
					error = ParseLargeImage(child->GetFirstChild());                        
				}
					
			// m[h OfferSummary ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "OfferSummary") {		
				// OfferSummary ^Ỏ͂邩ǂ        
				if (_isParseOfferSummary) {							
					// OfferSummary ͂                           
					error = ParseOfferSummary(child->GetFirstChild());        
				}
					
			// m[h Offers ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "Offers") {		
				// Offers ^Ỏ͂邩ǂ                       
				if (_isParseOffers) {		
					// Offers ͂
					error = ParseOffers(child->GetFirstChild());
				}

			// m[h CustomerReviews ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "CustomerReviews") {
				// CustomerReviews ^Ỏ͂邩ǂ
				if (_isParseCustomerReviews) {		
					// CustomerReviews ͂        
					error = ParseCustomerReviews(child->GetFirstChild());        
				}
			
			// m[h SimilarProducts ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "SimilarProducts") {			
				// SimilarProducts ^Ỏ͂邩ǂ            
				if (_isParseSimilarProducts) {						
					// SimilarProducts ͂        
					error = ParseSimilarProducts(child->GetFirstChild());        
				}
				
			// m[h BrowseNodes ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "BrowseNodes") {						
				// BrowseNodes ^Ỏ͂邩ǂ                        
				if (_isParseBrowserNodes) {							
					// BrowseNodes ͂        
					error = ParseBrowserNodes(child->GetFirstChild());        
				}
					
			// m[h ListmaniaLists ̏ꍇ            
			} else if (SFXAnsiString(child->GetNodeName()) == "ListmaniaLists") {						
				// ListmaniaLists ^Ỏ͂邩ǂ                   
				if (_isParseListmaniaLists) {						
					// ListmaniaLists ͂        
					error = ParseListmaniaLists(child->GetFirstChild());        
				}
			}
		}
	
	// Item ^OȂꍇ
	} else {

		error = SFERR_INVALID_STATE;
		
	}  // XML ̉ end

    return error;
}

// wp[֐
SFXDate StringToDate(SFXAnsiStringConstRef string)
{
    SFXDate ret(0);

	// Nݒ肷
    if (string.GetLength() >= 10) {
        ret.SetDate(static_cast<SInt16>(string.Substring(0, 4).AsUInt32()),
                    static_cast<SInt16>(string.Substring(5, 7).AsUInt32()),
                    static_cast<SInt16>(string.Substring(8, 10).AsUInt32()));
    }
    else if (string.GetLength() >= 7) {
        ret.SetDate(static_cast<SInt16>(string.Substring(0, 4).AsUInt32()),
                    static_cast<SInt16>(string.Substring(5, 7).AsUInt32()), 1);
    }
    return ret;
}

// ItemAttributes ^Ỏ
SFCError SGXAWSParser::ParseItemAttributes(SFXXMLNodePtr node)
{
    SFCError error(SFERR_NO_ERROR);

	// m[hꍇs	
    if (node == null) return SFERR_FAILED;

	// _itemAttributes \̂쐬
	_itemAttributes = new ItemAttributesRec;
    if (_itemAttributes == null) return SFERR_NO_MEMORY;
 
	// itemAttributes \̂̏
	_itemAttributes->numberOfPages = 0;
    _itemAttributes->packageDimensionsLength = 0;
    _itemAttributes->packageDimensionsWidth = 0;

	
	while(node != null && error == SFERR_NO_ERROR){
		// m[h Binding ̏ꍇ
		if (SFXAnsiString(node->GetNodeName()) == "Binding") {
			// m[h̕擾     
			error = SFXTextEncoding::UTF8ToShiftJIS( DecodeHtml(node->GetText()), &_itemAttributes->binding);
			if(error != SFERR_NO_ERROR) return error;
        
		// m[h Creator ̏ꍇ
		} else if (SFXAnsiString(node->GetNodeName()) == "Creator") {   	
			
			SFXXMLElementPtr element = static_cast<SFXXMLElementPtr>(node);

			//  1 ȏ㎝Ă邩ǂ𔻒肷
			if (element->HasAttributes()) {

				SFXAnsiString temp1,temp2;
						
				// UTF-8  ShiftJIS ɕύX
				error = SFXTextEncoding::UTF8ToShiftJIS( DecodeHtml(element->GetAttributes()->Item(0)->GetText()), &temp1);
				if(error != SFERR_NO_ERROR) return error;	
				// UTF-8  ShiftJIS ɕύX
				error = SFXTextEncoding::UTF8ToShiftJIS( DecodeHtml(element->GetText()), &temp2);
				if(error != SFERR_NO_ERROR) return error;		

				// L[Ɋ֘Atꂽl𖖔ɒǉ	
				error = _itemAttributes->creator.Append( temp1 , temp2 );
				if(error != SFERR_NO_ERROR) return error;
                    
			}
                
		}
        // m[h ListPrice ̏ꍇ
		else if (SFXAnsiString(node->GetNodeName()) == "ListPrice") {
			// ListPrice ȉ̃m[h擾
			SFXXMLNodePtr node2(node->GetFirstChild());

			while(node2 != null){

				// m[h Amount ̏ꍇ        
				if (SFXAnsiString(node2->GetNodeName()) == "Amount") {
					// m[h̕擾       
					_itemAttributes->amount = node2->GetText().AsSInt32();
                // m[h CurrencyCode ̏ꍇ        
				} else if (SFXAnsiString(node2->GetNodeName()) == "CurrencyCode") {
					// UTF-8  ShiftJIS ɕύX		
					error = SFXTextEncoding::UTF8ToShiftJIS(DecodeHtml(node2->GetText()), &_itemAttributes->currencyCode);
					if(error != SFERR_NO_ERROR) return error;			
				// m[h FormattedPrice ̏ꍇ   		
				} else if (SFXAnsiString(node2->GetNodeName()) == "FormattedPrice") {
					// UTF-8  ShiftJIS ɕύX				
					error = SFXTextEncoding::UTF8ToShiftJIS(DecodeHtml(node2->GetText()), &_itemAttributes->formattedPrice);
					if(error != SFERR_NO_ERROR) return error;        
				}
				// ̃m[h擾
				node2 = node2->GetNextSibling();
			}
                
		// m[h NumberOfPages ̏ꍇ
		} else if (SFXAnsiString(node->GetNodeName()) == "NumberOfPages") {
             // m[h̕擾           
			_itemAttributes->numberOfPages = node->GetText().AsSInt32();
                
		// m[h PackageDimensions ̏ꍇ
		} else if (SFXAnsiString(node->GetNodeName()) == "PackageDimensions") {
            // PackageDimensions ȉ̃m[h擾        
			SFXXMLNodePtr node2(node->GetFirstChild());
                    
			while(node2 != null){    
                // m[h Length ̏ꍇ   
				if (SFXAnsiString(node2->GetNodeName()) == "Length") {
                    // m[h̕擾         
					_itemAttributes->packageDimensionsLength = node2->GetText().AsSInt32();
                // m[h Width ̏ꍇ          
				} else if (SFXAnsiString(node2->GetNodeName()) == "Width") {
                    // m[h̕擾         
					_itemAttributes->packageDimensionsWidth = node2->GetText().AsSInt32();
                       
				}
				// ̃m[h擾
				node2 = node2->GetNextSibling();                 
			}
                
		// m[h ProductGroup ̏ꍇ
		} else if (SFXAnsiString(node->GetNodeName()) == "ProductGroup") {
			// UTF-8  ShiftJIS ɕύX		
			error = SFXTextEncoding::UTF8ToShiftJIS( DecodeHtml(node->GetText()), &_itemAttributes->productGroup);
            if(error != SFERR_NO_ERROR) return error;       
		
		// m[h PublicationDate ̏ꍇ
		} else if (SFXAnsiString(node->GetNodeName()) == "PublicationDate") {
			// m[h̕擾     		
			_itemAttributes->publicationDate = StringToDate(node->GetText());
                
		// m[h Publisher ̏ꍇ
		} else if (SFXAnsiString(node->GetNodeName()) == "Publisher") {
			// UTF-8  ShiftJIS ɕύX				
			error = SFXTextEncoding::UTF8ToShiftJIS( DecodeHtml(node->GetText()), &_itemAttributes->publisher );
            if(error != SFERR_NO_ERROR) return error;   

		// m[h Title ̏ꍇ
		} else if (SFXAnsiString(node->GetNodeName()) == "Title") {
			// UTF-8  ShiftJIS ɕύX			
			error = SFXTextEncoding::UTF8ToShiftJIS( DecodeHtml(node->GetText()), &_title );
			if(error != SFERR_NO_ERROR) return error;  
                
		}

		// ̃m[h擾
		node = node->GetNextSibling();
	}
		
    return error;
}

// ^Cĝ݂́iItemAttributes ^Ỏ͂ȂƂɎsj
SFCError SGXAWSParser::ParseTitle(SFXXMLNodePtr node)
{
    SFCError error(SFERR_NO_ERROR);

    if (node == null) return SFERR_FAILED;

	while(node != null){
		// m[h^Cg̏ꍇ
		if (SFXAnsiString(node->GetNodeName()) == "Title") {
			// m[h̕擾 
			_title = DecodeHtml(node->GetText());
		}

		// ̃m[h擾
		node = node->GetNextSibling();  
	}

    return error;
}

// SmallImage ^Ỏ͂
SFCError SGXAWSParser::ParseSmallImage(SFXXMLNodePtr node)
{
    SFCError error(SFERR_NO_ERROR);

    if (node == null) return SFERR_FAILED;
    
	// _imageUrl \̂쐬
	if (_imageUrl == null) {   
		_imageUrl = new ImageUrlRec;     
	}
        
	// _imageUrl \̂쐬łȂꍇ
	if (_imageUrl == null) return SFERR_NO_MEMORY;
	
	while(node != null){

		// m[h URL ̏ꍇ		
		if (SFXAnsiString(node->GetNodeName()) == "URL") {     
			// m[h̕擾 
			_imageUrl->smallImageURL = DecodeHtml(node->GetText());
               
		// m[h Height ̏ꍇ	
		} else if (SFXAnsiString(node->GetNodeName()) == "Height") {   
			// m[h̕擾 
			_imageUrl->smallImageHeight = node->GetText().AsSInt32();
           
		// m[h Width ̏ꍇ	
		} else if (SFXAnsiString(node->GetNodeName()) == "Width") { 
			// m[h̕擾
			_imageUrl->smallImageWidth = node->GetText().AsSInt32();
                
		}				
		// ̃m[h擾				
		node = node->GetNextSibling();  
	}
    return error;
}

// MediumImage ^Ỏ͂
SFCError SGXAWSParser::ParseMediumImage(SFXXMLNodePtr node)
{
    SFCError error(SFERR_NO_ERROR);

	if (node == null) return SFERR_FAILED;

	// _imageUrl \̂쐬
	if (_imageUrl == null) {   
		_imageUrl = new ImageUrlRec;     
	}
        
	// _imageUrl \̂쐬łȂꍇ
	if (_imageUrl == null) return SFERR_NO_MEMORY;

	while(node != null){

		// m[h URL ̏ꍇ	
		if (SFXAnsiString(node->GetNodeName()) == "URL") {
            // m[h̕擾        
			_imageUrl->mediumImageURL = DecodeHtml(node->GetText());
        
		// m[h Height ̏ꍇ	
		} else if (SFXAnsiString(node->GetNodeName()) == "Height") {
            // m[h̕擾        
			_imageUrl->mediumImageHeight = node->GetText().AsSInt32();
   
		// m[h Width ̏ꍇ	
		} else if (SFXAnsiString(node->GetNodeName()) == "Width") {
            // m[h̕擾       
			_imageUrl->mediumImageWidth = node->GetText().AsSInt32();               
		}
		
		// ̃m[h擾				
		node = node->GetNextSibling();
	}

    return error;
}

// LargeImage ^Ỏ͂
SFCError SGXAWSParser::ParseLargeImage(SFXXMLNodePtr node)
{
    SFCError error(SFERR_NO_ERROR);

	if (node == null) return SFERR_FAILED;

	// _imageUrl \̂쐬
	if (_imageUrl == null) {   
		_imageUrl = new ImageUrlRec;     
	}
        
	// _imageUrl \̂쐬łȂꍇ
	if (_imageUrl == null) return SFERR_NO_MEMORY;

	while(node != null){

		// m[h URL ̏ꍇ	
		if (SFXAnsiString(node->GetNodeName()) == "URL") {
			// m[h̕擾 
			_imageUrl->largeImageURL = DecodeHtml(node->GetText());

		// m[h Height ̏ꍇ	
		} else if (SFXAnsiString(node->GetNodeName()) == "Height") {
			// m[h̕擾 
			_imageUrl->largeImageHeight = node->GetText().AsSInt32();

		// m[h Width ̏ꍇ	
		} else if (SFXAnsiString(node->GetNodeName()) == "Width") {
			// m[h̕擾 
			_imageUrl->largeImageWidth = node->GetText().AsSInt32();

		}

		// ̃m[h擾				
		node = node->GetNextSibling();
    }

	return error;

}

// CustomerReviews ^Ỏ͂
SFCError SGXAWSParser::ParseCustomerReviews(SFXXMLNodePtr node)
{
    SFCError error(SFERR_NO_ERROR);

	if (node == null) return SFERR_FAILED;

	// _customerReviews \̂쐬
	_customerReviews = new CustomerReviewsRec;

	// _customerReviews \̂쐬łȂꍇ
	if (_customerReviews == null) return SFERR_NO_MEMORY;
      
	while(node != null && error == SFERR_NO_ERROR){
			
		// m[h AverageRating ̏ꍇ	
		if (SFXAnsiString(node->GetNodeName()) == "AverageRating") {
			// m[h̕擾 
			_customerReviews->avarageRating = node->GetText().AsSInt32();

		// m[h TotalReviews ̏ꍇ	
		} else if (SFXAnsiString(node->GetNodeName()) == "TotalReviews") {
			// m[h̕擾 
			_customerReviews->totalReviews = node->GetText().AsSInt32();

		// m[h TotalReviewPages ̏ꍇ
		} else if (SFXAnsiString(node->GetNodeName()) == "TotalReviewPages") {
			// m[h̕擾 
			_customerReviews->totalReviewPages = node->GetText().AsSInt32();

		// m[h Review ̏ꍇ
		} else if (SFXAnsiString(node->GetNodeName()) == "Review") {

			SFXXMLNodePtr node2(node->GetFirstChild());

			// review \̂쐬
			ReviewRecPtr review = new ReviewRec;

			// review \̂쐬łȂꍇ
			if (review == null) return SFERR_NO_MEMORY;

				while(node2 != null){

					// m[h ASIN ̏ꍇ
					if (SFXAnsiString(node2->GetNodeName()) == "ASIN") {
						// m[h̕擾 
						review->asin = DecodeHtml(node2->GetText());

					// m[h Rating ̏ꍇ
					} else if (SFXAnsiString(node2->GetNodeName()) == "Rating") {
						// m[h̕擾 
						review->rating = node2->GetText().AsSInt32();

					// m[h HelpfulVotes ̏ꍇ
					} else if (SFXAnsiString(node2->GetNodeName()) == "HelpfulVotes") {
						// m[h̕擾 
						review->helpfulVotes = node2->GetText().AsSInt32();

					// m[h CustomerId ̏ꍇ
					} else if (SFXAnsiString(node2->GetNodeName()) == "CustomerId") {
						// m[h̕擾
						review->customerId = DecodeHtml(node2->GetText());

					// m[h TotalVotes ̏ꍇ
					} else if (SFXAnsiString(node2->GetNodeName()) == "TotalVotes") {
						// m[h̕擾
						review->totalVotes = node2->GetText().AsSInt32();

					// m[h Date ̏ꍇ
					} else if (SFXAnsiString(node2->GetNodeName()) == "Date") {
						// m[h̕擾
						review->date = StringToDate(node2->GetText());

					// m[h Summary ̏ꍇ
					} else if (SFXAnsiString(node2->GetNodeName()) == "Summary") {
						// m[h̕擾
						review->summary = DecodeHtml(node2->GetText());

					// m[h Content ̏ꍇ
					} else if (SFXAnsiString(node2->GetNodeName()) == "Content") {
						// m[h̕擾
						review->content = DecodeHtml(node2->GetText());

					}

					// ̃m[h擾				
					node2 = node2->GetNextSibling();
				}

				// _customerReviews ǉ
				error = _customerReviews->reviews.Append(review);

			}

		// ̃m[h擾				
		node = node->GetNextSibling();
	}

    return error;
}

// SimilarProducts ^Ỏ͂
SFCError SGXAWSParser::ParseSimilarProducts(SFXXMLNodePtr node)
{
    SFCError error(SFERR_NO_ERROR);

	if (node == null) return SFERR_FAILED;

	// _similarProducts \̂쐬
	_similarProducts = new SimilarProductsRec;

	// _similarProducts \̂쐬łȂꍇ
	if (_similarProducts == null) return SFERR_NO_MEMORY;

	while(node != null && error == SFERR_NO_ERROR){
        // m[h SimilarProduct ̏ꍇ      
		if (SFXAnsiString(node->GetNodeName()) == "SimilarProduct") {

			SFXXMLNodePtr node2(node->GetFirstChild());

			// similarProduct \̂쐬
			SimilarProductRecPtr similarProduct = new SimilarProductRec;

			// similarProduct \̂쐬łȂꍇ
			if (similarProduct == null) return SFERR_NO_MEMORY;

			while(node2 != null){

				// m[h ASIN ̏ꍇ      
				if (SFXAnsiString(node2->GetNodeName()) == "ASIN") {
					// m[h̕擾
					similarProduct->asin = DecodeHtml(node2->GetText());
                
				// m[h Title ̏ꍇ   
				} else if (SFXAnsiString(node2->GetNodeName()) == "Title") {
					// m[h̕擾
					similarProduct->title = DecodeHtml(node2->GetText());
				}

				// ̃m[h擾				
				node2 = node2->GetNextSibling();        
			}
            
			// similarProduct ǉ
			error = _similarProducts->similarProducts.Append(similarProduct);
                    
		}
		// ̃m[h擾				
		node = node->GetNextSibling();  
    }
    return error;
}


// Not yet implimentation.
SFCError SGXAWSParser::ParseBrowserNodes(SFXXMLNodePtr /*node*/){ return SFERR_NO_ERROR;}
SFCError SGXAWSParser::ParseListmaniaLists(SFXXMLNodePtr /*node*/){ return SFERR_NO_ERROR;}
SFCError SGXAWSParser::ParseOfferSummary(SFXXMLNodePtr /*node*/){ return SFERR_NO_ERROR;}
SFCError SGXAWSParser::ParseOffers(SFXXMLNodePtr /*node*/){ return SFERR_NO_ERROR;}

